package org.myorg;

import java.io.*;
import java.util.*;

import org.apache.hadoop.fs.Path;
import org.apache.hadoop.conf.*;
import org.apache.hadoop.io.*;
import org.apache.hadoop.mapreduce.*;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.input.TextInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;
import org.apache.hadoop.mapreduce.lib.output.TextOutputFormat;
import org.apache.hadoop.util.GenericOptionsParser;

class pt
{
	public double x;
	public double y;
	public double z;
 
        public pt()
        {
        }
	public pt(double x, double y, double z)
  	{
		this.x=x;
		this.y=y;
		this.z=z;
	}
      
        public String toString()
	{
		return x+" "+y+" "+z;
	}

        public double distSqr(pt p)
        {
		return (x-p.x)*(x-p.x)+(y-p.y)*(y-p.y)+(z-p.z)*(z-p.z);
	}
};

	class kdTNode
	{
		public pt[] PT;
		public int numPt;
		public pt lowBoundary;
		public pt highBoundary;
		public int axis;	//0=x, 1=y, 2=z
		public double split;
		
		public kdTNode left;
		public kdTNode right;
		
		public kdTNode(pt[] points)
		{
			PT=null;
			numPt=points.length;		
			axis=0;	//initial node
			
			lowBoundary = new pt();
			highBoundary= new pt();
		}
	};

	class kdTree
	{
		kdTNode root;
		
		//public static int c, cs;
		pt min;
		pt max;
		static double satis[];
		static double boundary[];
		double factor;

		static double logFactor;
		
		static double distSqr(pt pt1, pt pt2)
		{
			return (pt1.x-pt2.x)*(pt1.x-pt2.x)+(pt1.y-pt2.y)*(pt1.y-pt2.y)+(pt1.z-pt2.z)*(pt1.z-pt2.z);
		}

		
		double minD=0.000001f;	//min distance to stop split
		int minNum=3;					//min point in the cell to stop split
		
		 public static void quickSelect(pt [ ] a,int flag) {
			 
		     quickSelect( a, 0, a.length - 1, a.length/2 , flag);
		 }
		 
		 public static void quickSelect( pt [ ] a, int low, int high, int k ,int flag) {
		    //System.out.println(low+" "+high+" "+k+" "+flag); 
		    if( low + CUTOFF > high )
			 insertionSort( a, low, high,flag );
		     else {
			 // Sort low, middle, high
			 int middle = ( low + high ) / 2;
			 if(flag==0)
			 {
				 if( a[ middle ].x< a[ low ].x )
				     swapReferences( a, low, middle );
				 if( a[ high ].x< a[ low ].x )
				     swapReferences( a, low, high );
				 if( a[ high ].x< a[ middle ].x )
				     swapReferences( a, middle, high );
			 }
			 if(flag==1)
			 {
				 if( a[ middle ].y< a[ low ].y )
				     swapReferences( a, low, middle );
				 if( a[ high ].y< a[ low ].y )
				     swapReferences( a, low, high );
				 if( a[ high ].y< a[ middle ].y )
				     swapReferences( a, middle, high );
			 }
			 if(flag==2)
			 {
				 if( a[ middle ].z< a[ low ].z )
				     swapReferences( a, low, middle );
				 if( a[ high ].z< a[ low ].z )
				     swapReferences( a, low, high );
				 if( a[ high ].z< a[ middle ].z )
				     swapReferences( a, middle, high );
			 }

			 // Place pivot at position high - 1
			 swapReferences( a, middle, low );
			 pt pivot = new pt();
			 pivot.x = a[ low ].x;
			 pivot.y = a[ low ].y;
			 pivot.z = a[ low ].z;
			 
			 // Begin partitioning
			 int i=low, j=high;

			 if(flag==0)
			 {
				while (true)
				{
					//System.out.println(i + " " + j + " " + a[j].x + " " + a[i].x + " " + pivot.x);
					while (a[j].x>pivot.x)
						j--;
					while (a[i].x<pivot.x)
						i++;
					
					if (i<j && a[i].x ==pivot.x && a[j].x == pivot.x)
					{
						swapReferences(a, i+1, j);
						i++;
					} 

					else if (i<j)
						swapReferences(a, i, j);	         		
					else
						break;
					
				}
			 }
			 else if(flag==1)
			 {
				while (true)
				{
					//System.out.println(i + " " + j + " " + a[j].y + " " + a[i].y + " " + pivot.y);
					while (a[j].y>pivot.y)
						j--;
					while (a[i].y<pivot.y)
						i++;
					
					
					if (i<j && a[i].y ==pivot.y && a[j].y == pivot.y)
					{
						swapReferences(a, i+1, j);
						i++;
					} 

					else if (i<j)
						swapReferences(a, i, j);
					else
						break;
					
				}

			}
			else
			{
				while (true)
				{
					//System.out.println(i + " " + j + " " + a[j].z + " " + a[i].z + " " + pivot.z);
					while (a[j].z>pivot.z)
						j--;
					while (a[i].z<pivot.z)
						i++;
									
					if (i<j && a[i].z ==pivot.z && a[j].z == pivot.z)
					{
						swapReferences(a, i+1, j);
						i++;
					} 
					else if (i<j)
						swapReferences(a, i, j);

					else
						break;
					
				}
							
			}	
							  
			 // Recurse; only this part changes
			 if( k <= i )
			     quickSelect( a, low, j - 1, k ,flag);
			 else if( k >= j + 1 )
			     quickSelect( a, j + 1, high, k ,flag);
		     }
		 }
		 
		 private static void insertionSort( pt [ ] a, int low, int high ,int flag) {
		     for( int p = low + 1; p <= high; p++ ) {
			 pt tmp =new pt();
			 tmp.x= a[ p ].x;
			 tmp.y= a[ p ].y;
			 tmp.z= a[ p ].z;
			 
			 int j;
			 if(flag==0)
			 {
				 for( j = p; j > low && tmp.x<a[ j - 1 ].x; j-- )
				 {
					 a[ j ].x = a[ j - 1 ].x;
					 a[ j ].y = a[ j - 1 ].y;
					 a[ j ].z = a[ j - 1 ].z;
					}
			 }
			 else if(flag==1)
			 {
				 for( j = p; j > low && tmp.y<a[ j - 1 ].y; j-- )
				{
					 a[ j ].x = a[ j - 1 ].x;
					 a[ j ].y = a[ j - 1 ].y;
					 a[ j ].z = a[ j - 1 ].z;
					}
			 }
			 else
			 {
				 for( j = p; j > low && tmp.z<a[ j - 1 ].z; j-- )
				{
					 a[ j ].x = a[ j - 1 ].x;
					 a[ j ].y = a[ j - 1 ].y;
					 a[ j ].z = a[ j - 1 ].z;
					}
			 }
			 a[ j ].x = tmp.x;
			 a[ j ].y = tmp.y;
			 a[ j ].z = tmp.z;
		     }
		 }
		 
		 
		 private static final int CUTOFF = 15;

		 public static final void swapReferences( pt [ ] a, int index1, int index2 ) {
		     pt tmp = new pt();
		     tmp.x = a[ index1 ].x;
		     tmp.y = a[ index1 ].y;
		     tmp.z = a[ index1 ].z;
		     a[ index1 ].x = a[ index2 ].x;
		     a[ index1 ].y = a[ index2 ].y;
		     a[ index1 ].z = a[ index2 ].z;
		     a[ index2 ].x = tmp.x;
		     a[ index2 ].y = tmp.y;
		     a[ index2 ].z = tmp.z;
		 }
			 
		public void construct_Tree(kdTNode node, pt[] points)
		{
			//System.out.println(points.length);
			if ((node.highBoundary.x-node.lowBoundary.x<minD && node.highBoundary.y-node.lowBoundary.y<minD && node.highBoundary.z-node.lowBoundary.z<minD) || (node.numPt<minNum))
			{
				node.PT = new pt[points.length];
				for (int i=0;i<points.length;i++)
				{
					node.PT[i] = new pt();
					node.PT[i].x = points[i].x;
					node.PT[i].y = points[i].y;
					node.PT[i].z = points[i].z;
				}
				
				node.left=node.right=null;
				node.numPt=points.length;	
				return;
			}		
			
			//System.out.println("pstart");		
			quickSelect(points, node.axis);
			//System.out.println("pend");

			int k=points.length/2;

			if (node.axis==0)
				node.split = points[k].x;
			else if (node.axis==1)
				node.split = points[k].y;
			else
				node.split = points[k].z;
			
			//recursion		
			//System.out.println(k);
			pt[] ptL = new pt[k+1];
			pt[] ptR = new pt[points.length-k-1];
			
			for (int i=0;i<k+1;i++)
			{
				ptL[i] = new pt();
				ptL[i].x = points[i].x;	
				ptL[i].y = points[i].y;	
				ptL[i].z = points[i].z;	
			}
			
			for (int i=k+1;i<points.length;i++)
			{
				ptR[i-k-1] = new pt();
				ptR[i-k-1].x = points[i].x;
				ptR[i-k-1].y = points[i].y;
				ptR[i-k-1].z = points[i].z;
			}
			
			node.left = new kdTNode(ptL);
			node.right= new kdTNode(ptR);

			node.left.axis = node.right.axis = (node.axis+1)%3;

			node.left.lowBoundary.x= node.right.lowBoundary.x=node.lowBoundary.x;
			node.left.lowBoundary.y= node.right.lowBoundary.y=node.lowBoundary.y;
			node.left.lowBoundary.z= node.right.lowBoundary.z=node.lowBoundary.z;

			node.left.highBoundary.x=node.right.highBoundary.x=node.highBoundary.x;
		node.left.highBoundary.y=node.right.highBoundary.y=node.highBoundary.y;		node.left.highBoundary.z=node.right.highBoundary.z=node.highBoundary.z;
			
			if (node.axis==0)			node.left.highBoundary.x=node.right.lowBoundary.x=node.split;
			else if (node.axis==1)
		node.left.highBoundary.y=node.right.lowBoundary.y=node.split;
			else			node.left.highBoundary.z=node.right.lowBoundary.z=node.split;
				
				
			construct_Tree(node.left, ptL);
			construct_Tree(node.right,ptR);
		}
		
		public void traverse(kdTNode node)
		{
			//System.out.println("traverse");
			if (node==null)
				return;
				
			if (node.PT==null)
			{
				traverse(node.left);
				traverse(node.right);
			}
			else
			{
				for (int i=0;i<node.numPt;i++)
					System.out.println(node.PT[i].x+" "+node.PT[i].y+" "+node.PT[i].z);
			}
		}

		public void calculateCF_kdtreeSeries(double small, double big, double facto)
		{
		  factor  = facto;

		  System.out.println("Series Kd-tree O(N^(5/3)) algorithm");
		  int num = (int)Math.floor(Math.log(big/small)/Math.log(factor))+1;
		  System.out.println(small+" to "+big+", totally "+num+" ranges");

		  logFactor = Math.log(factor);

		  long t1 = System.currentTimeMillis();

		  satis = new double[num];
		  boundary = new double[num];
		  for (int i=0;i<num;i++)
		  {	  	  	
			satis[i] = 0;
			boundary[i] = Math.pow(small * Math.pow(facto,i+1),2);	//notice, +1
		  }

		  calculateCF_Series(small,big,root,root);

		  for (int i=0;i<num;i++)
			System.out.println(i+"\t"+satis[i]/2);
		  System.out.println((System.currentTimeMillis()-t1)/1000.0+" sec");
		}


		public void calculateCF_Series(double small, double big, kdTNode p, kdTNode q)
		{
			//cs++;
			if (p==null || q==null)
				return;
			
			double maxDistSqr, minDistSqr;			
			double maxX, minX, maxY, minY, maxZ, minZ, dis;		
			
			if (p.lowBoundary.x>q.highBoundary.x)
			{
				minX=p.lowBoundary.x-q.highBoundary.x;
				maxX=p.highBoundary.x-q.lowBoundary.x;
			}
			else if (q.lowBoundary.x>p.highBoundary.x)
			{
				minX=q.lowBoundary.x-p.highBoundary.x;
				maxX=q.highBoundary.x-p.lowBoundary.x;
			}
			else
			{
				minX=0;
				maxX=Math.max(q.highBoundary.x-p.lowBoundary.x, p.highBoundary.x-q.lowBoundary.x);
			}
			
			
			if (p.lowBoundary.y>q.highBoundary.y)
			{
				minY=p.lowBoundary.y-q.highBoundary.y;
				maxY=p.highBoundary.y-q.lowBoundary.y;
			}
			else if (q.lowBoundary.y>p.highBoundary.y)
			{
				minY=q.lowBoundary.y-p.highBoundary.y;
				maxY=q.highBoundary.y-p.lowBoundary.y;
			}
			else
			{
				minY=0;
				maxY=Math.max(q.highBoundary.y-p.lowBoundary.y, p.highBoundary.y-q.lowBoundary.y);
			}

			
			if (p.lowBoundary.z>q.highBoundary.z)
			{
				minZ=p.lowBoundary.z-q.highBoundary.z;
				maxZ=p.highBoundary.z-q.lowBoundary.z;
			}
			else if (q.lowBoundary.z>p.highBoundary.z)
			{
				minZ=q.lowBoundary.z-p.highBoundary.z;
				maxZ=q.highBoundary.z-p.lowBoundary.z;
			}
			else
			{
				minZ=0;
				maxZ=Math.max(q.highBoundary.z-p.lowBoundary.z, p.highBoundary.z-q.lowBoundary.z);
			}
			
			maxDistSqr = maxX*maxX+maxY*maxY+maxZ*maxZ;
			minDistSqr = minX*minX+minY*minY+minZ*minZ;
			
			//judge
			
			double bigSqr = big*big, smallSqr = small*small;
			if (minDistSqr>bigSqr)
			{		
				return;			
			}

			if (maxDistSqr<smallSqr)
				return;


			//more work here
			/*
			if (maxDistSqr<bigSqr && minDistSqr>smallSqr)
			{
				return p.numPt*q.numPt;
			}
			*/


			if (maxDistSqr/minDistSqr<factor)
			{
				
				int sindex = (int)(Math.log(minDistSqr/smallSqr) / 2 / logFactor);
				//int bindex = (int)Math.floor(Math.log(maxDistSqr/smallSqr) / 2 / logFactor);
				
				if (maxDistSqr<boundary[sindex])
				{
					satis[sindex] += p.numPt*q.numPt;
					//System.out.println("!! !  "+sindex+" "+p.numPt+" "+q.numPt);
					return;
				}
			}
			
			if (p.PT!=null && q.PT!=null)	//endPoint Vs endPoint
			{
				int toR=0;
				for (int i=0;i<p.PT.length;i++)
					for (int j=0;j<q.PT.length;j++)
					{
						double smallS = small*small, bigS = big*big;
						double disS = distSqr(p.PT[i],q.PT[j]);
						if (disS<smallS || disS>bigS)
							;
						else
						{
							//System.out.println("?? ?  "+disS+" "+p.numPt+" "+q.numPt);
													
							int index = (int)(Math.log(disS/smallS) / 2 / logFactor);
							//System.out.println(disS+" "+smallS+" "+logFactor);
							satis[index]++;
						}

					}				
				return;
			}
			
			if (p.PT==null && q.PT==null)	//branch Vs branch
			{
				if (p.numPt>q.numPt)
				{
					calculateCF_Series(small,big,p.left,q);
					calculateCF_Series(small,big,p.right,q);
				}
				else
				{
					calculateCF_Series(small,big,q.left,p);
					calculateCF_Series(small,big,q.right,p);
				}
			}
			
			else if (p.PT==null)	//p branch Vs q endpoint
			{
				calculateCF_Series(small,big,p.left,q);
				calculateCF_Series(small,big,p.right,q);
			}
			
			else //p endpoint Vs q branch
			{
				calculateCF_Series(small,big,q.left,p);
				calculateCF_Series(small,big,q.right,p);
			}

		}
		


		
		public double calculateCF_kdtree(double small, double big)
		{
		  //System.out.println("Kd-tree O(N^(5/3)) algorithm");
		  long t1 = System.currentTimeMillis();

			long numerator  = calculateCF(small,big,root,root);
			long denominator= root.numPt*(root.numPt-1);
			return numerator/2.0;

			//System.out.println(numerator/2.0+" "+(System.currentTimeMillis()-t1)/1000.0+" sec");
		}
			
		public long calculateCF(double small, double big, kdTNode p, kdTNode q)
		{
			//c++;
			if (p==null || q==null)
				return 0;
			
			double maxDistSqr, minDistSqr;			
			double maxX, minX, maxY, minY, maxZ, minZ, dis;		
			
			if (p.lowBoundary.x>q.highBoundary.x)
			{
				minX=p.lowBoundary.x-q.highBoundary.x;
				maxX=p.highBoundary.x-q.lowBoundary.x;
			}
			else if (q.lowBoundary.x>p.highBoundary.x)
			{
				minX=q.lowBoundary.x-p.highBoundary.x;
				maxX=q.highBoundary.x-p.lowBoundary.x;
			}
			else
			{
				minX=0;
				maxX=Math.max(q.highBoundary.x-p.lowBoundary.x, p.highBoundary.x-q.lowBoundary.x);
			}
			
			
			if (p.lowBoundary.y>q.highBoundary.y)
			{
				minY=p.lowBoundary.y-q.highBoundary.y;
				maxY=p.highBoundary.y-q.lowBoundary.y;
			}
			else if (q.lowBoundary.y>p.highBoundary.y)
			{
				minY=q.lowBoundary.y-p.highBoundary.y;
				maxY=q.highBoundary.y-p.lowBoundary.y;
			}
			else
			{
				minY=0;
				maxY=Math.max(q.highBoundary.y-p.lowBoundary.y, p.highBoundary.y-q.lowBoundary.y);
			}

			
			if (p.lowBoundary.z>q.highBoundary.z)
			{
				minZ=p.lowBoundary.z-q.highBoundary.z;
				maxZ=p.highBoundary.z-q.lowBoundary.z;
			}
			else if (q.lowBoundary.z>p.highBoundary.z)
			{
				minZ=q.lowBoundary.z-p.highBoundary.z;
				maxZ=q.highBoundary.z-p.lowBoundary.z;
			}
			else
			{
				minZ=0;
				maxZ=Math.max(q.highBoundary.z-p.lowBoundary.z, p.highBoundary.z-q.lowBoundary.z);
			}
			
			maxDistSqr = maxX*maxX+maxY*maxY+maxZ*maxZ;
			minDistSqr = minX*minX+minY*minY+minZ*minZ;
			
			//judge
			
			double bigSqr = big*big, smallSqr = small*small;
			if (minDistSqr>bigSqr)
			{		
				//problem here
				//naive_test(small,big,p,q);
				return 0;			
			}

			if (maxDistSqr<smallSqr)
				return 0;

			if (maxDistSqr<bigSqr && minDistSqr>smallSqr)
			{
				return p.numPt*q.numPt;
			}
			
			if (p.PT!=null && q.PT!=null)	//endPoint Vs endPoint
			{
				int toR=0;
				for (int i=0;i<p.PT.length;i++)
					for (int j=0;j<q.PT.length;j++)
					{
						if (distSqr(p.PT[i],q.PT[j])>smallSqr && distSqr(p.PT[i],q.PT[j])<bigSqr)
							toR++;
					}				
				return toR;
			}
			
			if (p.PT==null && q.PT==null)	//branch Vs branch
			{
				if (p.numPt>q.numPt)
					return calculateCF(small,big,p.left,q)+calculateCF(small,big,p.right,q);
				else
					return calculateCF(small,big,q.left,p)+calculateCF(small,big,q.right,p);
			}
			
			if (p.PT==null)	//p branch Vs q endpoint
			{
				return calculateCF(small,big,p.left,q)+calculateCF(small,big,p.right,q);
			}
			
			else //p endpoint Vs q branch
				return calculateCF(small,big,q.left,p)+calculateCF(small,big,q.right,p);

		}
		
		public kdTree(ArrayList points, int num, double lowBoundary, double highBoundary)
		{
			max = new pt();
			min = new pt();
			//set min and max
			min.x=min.y=min.z=lowBoundary;
			max.x=max.y=max.z=highBoundary;

			pt[] intercept = new pt[num];
			for (int i=0;i<num;i++)
			{
				intercept[i] = new pt();
				intercept[i].x = ((pt)points.get(i)).x;
				intercept[i].y = ((pt)points.get(i)).y;
				intercept[i].z = ((pt)points.get(i)).z;
			}
					
			root = new kdTNode(intercept);
			root.lowBoundary.x=min.x;
			root.lowBoundary.y=min.y;
			root.lowBoundary.z=min.z;
			root.highBoundary.x=max.x;
			root.highBoundary.y=max.y;
			root.highBoundary.z=max.z;

			construct_Tree(root, intercept);
			//traverse(root);
		}
	};

public class DiscDistance
{
  public static int intervalNum;
  public static int sampleSet = 30;
  public static double globalResult[];
  public static double globalErr[];
  public static int flag[];
  public static double partResult[][];
  public static long total;
  public static double err;

  public static int offStart = 0;
  public static int offLength = 0;

  public static double globalMax=0;

  public static class Map extends Mapper<LongWritable,Text,IntWritable,Text>
  {
    private Text word = new Text();

    private int sampleSet = 30; //make it statistically significant

    public void map(LongWritable key, Text value, Context context) throws IOException, InterruptedException
    {
      String line = value.toString();
	     
      double sampleRate = (double)(context.getConfiguration().getFloat("rate",0.01f));
      for (int i=0;i<sampleSet;i++)
      {
	if (Math.random()<sampleRate)
	{
	  IntWritable one = new IntWritable(i);
	  word.set(line);
	  context.write(one,word);
	}
      }
    }
  }
	 
  public static class Reduce extends Reducer<IntWritable,Text,IntWritable,Text>
  {
    public void reduce(IntWritable key, Iterable<Text> values, Context context) throws IOException, InterruptedException
    {
      int index=0;
      Text word = new Text();
      ArrayList al = new ArrayList();

      double min = 9999999, max=-1;

      for (Text val : values)
      {
	StringTokenizer stk = new StringTokenizer(val.toString()," ");
        //stk.nextToken();
	double x = Double.parseDouble(stk.nextToken());
	double y = Double.parseDouble(stk.nextToken());
	double z = Double.parseDouble(stk.nextToken());
	pt data = new pt(x,y,z);      
	al.add(data);

	if (x>max)
	  max = x;
	if (y>max)
	  max = y;
	if (z>max)
	  max = z;
	if (x<min)
	  min = x;
	if (y<min)
	  min = y;
	if (z<min)
	  min = z;
      }
	   
      double s = (double)(context.getConfiguration().getFloat("s",1.0f));
      double b = (double)(context.getConfiguration().getFloat("b",2.0f));
      double f = (double)(context.getConfiguration().getFloat("f",2.0f));     
	   
      //send max
      word.set("l"+"\t"+max);
      context.write(key,word);
	 
      String method = context.getConfiguration().get("method");

      if (method.equals("kdtree"))
      {
        //Kd-tree
        kdTree kdtree = new kdTree(al, al.size(), min, max);
        index = 0;
        for (double ep=s; ep<b;ep=ep*f, index++)
        {
          double u = ep*f;
          if (u>b)
            u=b;
          double result = kdtree.calculateCF_kdtree(ep, u)/al.size()/al.size();
          word.set(index+"\t"+result);
          context.write(key,word);
        }
      }
      else if (method.equals("naive"))
      {
        //Naive
        LinkedList ll = Naive(al,s,b,f,context);
      
        Iterator ir = ll.iterator();
        while (ir.hasNext())
        {
          word.set(index+"\t"+ir.next());
          context.write(key,word);
          index++;
        }
      }
    }

    public static LinkedList Naive(ArrayList al, double s, double b, double f, Context c)
    {
      LinkedList ll = new LinkedList();
      int intervalNum = (int)Math.floor(Math.log(b/s)/Math.log(f))+1;
     
      int counter=0;
 
      double smallSqr = s*s, bigSqr = b*b;
      double logFactor = Math.log(f);
      double logSmallSqr = Math.log(smallSqr);

      double result[] = new double[intervalNum];
      for (int i=0;i<intervalNum;i++)
	result[i]=0;

      for (int i=0;i<al.size();i++)
	for (int j=i+1;j<al.size();j++)
	{
	  double disS = ((pt)(al.get(i))).distSqr((pt)al.get(j));
	  if (disS<smallSqr || disS>bigSqr)
	    ;
	  else
	  {
	    int index = (int)((Math.log(disS)-logSmallSqr)/2/logFactor);
	    result[index]++;
            counter++;

            if (counter%100000==0)
              c.progress();
	  }
	}
	  
      for (int i=0;i<intervalNum;i++)
      {
	//normalization
	result[i] = result[i]/al.size()/al.size();
	ll.add(result[i]);
      }

      return ll;
    }
  }

  public static void collectResult() throws Exception
  {
    String command = "hadoop fs -get CFoutput .";
    executeCommand(command);

    System.out.println(offStart);

    //load files
    File directory = new File("CFoutput/");
    String fileList[] = {"00000","00001","00002","00003","00004","00005","00006","00007","00008","00009","00010","00011","00012","00013","00014","00015","00016","00017","00018","00019","00020","00021","00022","00023","00024","00025","00026","00027","00028","00029"}; //directory.list();
    
    for (int i=0;i<fileList.length;i++)
    {
      //System.out.println(fileList[i]);
      BufferedReader br = new BufferedReader(new FileReader("CFoutput/part-r-"+fileList[i]));
      String s;
      while ((s=br.readLine())!=null)
      {
	String part[] = s.split("\t");
	if (part[1].equals("l"))
	{
	  double max = Double.parseDouble(part[2]);
	  if (max>globalMax)
	    globalMax = max;
	  continue;
	}
	int key = Integer.parseInt(part[0]);
	int sam = Integer.parseInt(part[1]);
	double res = Double.parseDouble(part[2]);

	//System.out.println(fileList[i]+" "+key+" "+sam+" "+res+" "+offStart);
	partResult[sam+offStart][key] = res*total*total;
	//System.out.println(s);
      }
    }    

    for (int i=offStart;i<offLength+offStart;i++)
      if (flag[i]==0)  
        testStats(i);

    command = "rm -dfr CFoutput/";
    executeCommand(command);
  }

  public static void testStats(int index)
  {
    double avg=0, std=0;
    for (int i=0;i<sampleSet;i++)
      avg += partResult[index][i];
    avg /= sampleSet;

    for (int i=0;i<sampleSet;i++)
      std += (partResult[index][i]-avg) * (partResult[index][i]-avg);
    std = std / sampleSet / (sampleSet - 1);
    std = Math.sqrt(std);

    globalResult[index] = avg;
    if (avg>0.000001)
    {
      globalErr[index]    = std*2/avg;
      if (std*2/avg<err)
        flag[index]=1;	//done
    }

    System.out.println(index+" "+avg*total*total+" "+std+" "+std*2/avg+" "+flag[index]);
  }

  public static void executeCommand(String str) throws Exception
  {
    String[] command = {"/bin/sh", "-c", str};
    Process process = Runtime.getRuntime().exec(command);
    InputStream is = process.getInputStream();
    InputStreamReader isr = new InputStreamReader(is);
    BufferedReader br = new BufferedReader(isr);

    while ((str=br.readLine())!=null)
      ;

    try
    {
      if (process.waitFor()!=0)
	System.err.println("exit value = "+process.exitValue());
    } catch(Exception o){}  
  }

  public static void main(String[] args) throws Exception
  {
    executeCommand("hadoop fs -rmr CFoutput");
    executeCommand("rm -dfr CFoutput");

    long startTime = System.currentTimeMillis();

    if (args.length!=6)
    {
      System.out.println("Wrong argument length!");
      System.exit(0);
    }

    Configuration conf = new Configuration();

    total = Long.parseLong(args[1]);
    float s = Float.parseFloat(args[2]);
    float b = Float.parseFloat(args[3]);
    float f = Float.parseFloat(args[4]);
    err = Double.parseDouble(args[5]);
	 
    intervalNum = (int)Math.floor(Math.log(b/s)/Math.log(f))+1;
    System.out.println(intervalNum);
    globalResult = new double[intervalNum];
    globalErr    = new double[intervalNum];
    flag = new int[intervalNum];
    partResult = new double[intervalNum][];

    offLength = intervalNum;

    for (int i=0;i<intervalNum;i++)
    {
      flag[i]=0; //unfinished
      partResult[i] = new double[sampleSet];
      globalErr[i] = 2.0; //indicate very bad precision
    }

    conf.setFloat("s",s);
    conf.setFloat("b",b);
    conf.setFloat("f",f);
    conf.setInt("iter",1);  //first M/R: small Naive to collect Statistics
    float sampleRate = (float)(8000.0/total);
    if (sampleRate>0.01)
      sampleRate=0.01f;

    conf.setFloat("rate", sampleRate);
    conf.set("method", "naive");

    String[] otherArgs = new GenericOptionsParser(conf, args).getRemainingArgs();
    Job job = new Job(conf, "wordcount"); 
    setJob(job,args);

    job.setNumReduceTasks(32);

    System.out.println(job.waitForCompletion(true));

    //now collect the result
    collectResult();

    executeCommand("hadoop fs -rmr CFoutput");
    executeCommand("rm -dfr CFoutput");

    //now calculate some statistics
    //split intervalNum to [0,p1) [p1,p2) and [p2,length)
    double e1 = globalMax*0.01, e2 = globalMax*1.5;
    
    int num1 = (int)Math.floor(Math.log(e1/s)/Math.log(f))+1;
    int num2 = (int)Math.floor(Math.log(e2/s)/Math.log(f))+1;

    if (num1<0)
      num1=0;
    if (num2<0)
      num2=0;
    if (num1>intervalNum)
      num1 = intervalNum;
    if (num2>intervalNum)
      num2 = intervalNum;

    //0 ~ (num1-1), num1 ~ (num2-1), num2 ~ intervalNum
    //first
    System.out.println("first "+0+" "+(num1-1));
    double maxErr = -1;
    for (int i=0;i<num1;i++)
    {
      System.out.println(globalErr[i]);
      if (globalErr[i]>maxErr)
        maxErr = globalErr[i];
    }
    double newSR = sampleRate;

    while (maxErr>err)
    {
      if (Math.abs(newSR-0.1)<0.00000001)
        break;

      //calculate new sample rate for kd-tree
      offLength = num1; 
      
      newSR = maxErr/err*newSR*1.5;
      double newb = s * Math.pow(f, num1);  

      System.out.println("err: "+maxErr+" rate: "+newSR);
      if (newSR>0.1)
        newSR = 0.1;

      conf.setFloat("rate", (float)newSR);
      conf.setFloat("b", (float)newb);
      conf.set("method", "kdtree");

      job = new Job(conf, "wordcount");
      setJob(job, args);
      job.setNumReduceTasks(32);

      System.out.println(job.waitForCompletion(true));

      collectResult();
      executeCommand("hadoop fs -rmr CFoutput");
      executeCommand("rm -dfr CFoutput");     

      maxErr=-1;
      for (int i=0;i<num1;i++)
      {
        System.out.println(globalErr[i]);
        if (globalErr[i]>maxErr)
          maxErr = globalErr[i];
      }
      //System.out.println("maxerr: "+maxErr);
    }

    //second
    System.out.println("second "+num1+" "+(num2-1));
    maxErr = -1;
    for (int i=num1;i<num2;i++)
    {
      if (globalErr[i]>maxErr)
        maxErr = globalErr[i];
    }
    newSR = sampleRate;

    System.out.println(maxErr);

    while (maxErr>err)
    {
      if (Math.abs(newSR-0.05)<0.00000001)
        break;

      offStart = num1;
      offLength = num2-num1;
      
      newSR = maxErr/err*newSR*1.5;
      double news = s * Math.pow(f, num1);
      double newb = s * Math.pow(f, num2) - 0.0001;
      if (newb > b)
        newb = b;

      System.out.println("err "+maxErr+" rate: "+newSR);
      if (newSR>0.05)
        newSR=0.05;
 
      conf.setFloat("s", (float)news);
      conf.setFloat("b", (float)newb);
      conf.setFloat("rate", (float)newSR);
      conf.set("method", "naive");

      job = new Job(conf, "wordcount");
      setJob(job, args);
      job.setNumReduceTasks(32);
 
      System.out.println(job.waitForCompletion(true));
 
      collectResult();
      executeCommand("hadoop fs -rmr CFoutput");
      executeCommand("rm -dfr CFoutput");

      maxErr=-1;

      for (int i=num1; i<num2; i++)
      {
        if (globalErr[i]>maxErr)
          maxErr = globalErr[i];
      }
      //System.out.println("maxerr: "+maxErr);
    }

    //third
    System.out.println("third "+num2+" "+intervalNum);
    maxErr=-1;
    for (int i=num2;i<intervalNum;i++)
    {
      if (globalErr[i]>maxErr)
        maxErr = globalErr[i];
    }
    newSR = sampleRate;
  
    System.out.println(maxErr);
 
    while (maxErr>err)
    {
      if (Math.abs(newSR-0.1)<0.00000001)
        break;
      offStart = num2;
      offLength = intervalNum-num2;

      newSR = maxErr/err*newSR*1.5;
      double news = s*Math.pow(f,num2);
      
      System.out.println("err "+maxErr+" rate: "+newSR);
      if (newSR>0.1)
        newSR=0.1;

      conf.setFloat("s", (float)news);
      conf.setFloat("b", (float)b);
      conf.setFloat("rate", (float)newSR);
      conf.set("method", "kdtree");

      job = new Job(conf, "wordcount");
      setJob(job, args);
      job.setNumReduceTasks(32);

      System.out.println(job.waitForCompletion(true));

      collectResult();
      executeCommand("hadoop fs -rmr CFoutput");
      executeCommand("rm -dfr CFoutput");  

      maxErr = -1;
 
      for (int i=num2;i<intervalNum;i++)
      {
        if (globalErr[i]>maxErr)
          maxErr = globalErr[i];
      }
      System.out.println("maxerr: "+maxErr);
    }

    System.out.println();
    System.out.println("small\tbig\tresult\terror");
    for (int i=0;i<intervalNum;i++)
    {
      double end = b;
      if (i!=intervalNum-1)
        end = s * Math.pow(f,i+1);
      System.out.println((s*Math.pow(f,i))+"\t"+end+"\t"+(globalResult[i])+"\t"+globalErr[i]);
    }
    System.out.println("total time: "+(System.currentTimeMillis()-startTime)/1000+" seconds");
  }
 
  public static void setJob(Job job, String args[]) throws Exception
  {
    job.setJarByClass(DiscDistance.class);
    job.setOutputKeyClass(IntWritable.class);
    job.setOutputValueClass(Text.class);
    job.setMapperClass(Map.class);
    job.setReducerClass(Reduce.class);
    job.setInputFormatClass(TextInputFormat.class);
    job.setOutputFormatClass(TextOutputFormat.class);
    FileInputFormat.addInputPath(job, new Path(args[0]));
    FileOutputFormat.setOutputPath(job, new Path("CFoutput"));
  }

}
